import java.awt.*;
import java.util.*;


/**
 *Subclase de Forma que permite agrupar distintas implementaciones de Formas, como Circulos y Rectangulos.
 *@author Patricio A. Castillo Pizarro - Eric C. Maldonado Olguin
 *@version 1.2 - April 12th, 2007
 */
public class Figura extends Forma
{
    private ArrayList<Forma> _figuras;
    /**
     *Es el constructor. Inicializa una nueva Figura
     */
    public Figura ()
    {
        _figuras = new ArrayList<Forma> ();
    }

    /**Metodo que permite agregar formas a la figura
     *@param forma La Forma a agregar al arreglo que compone la Figura
     */
    public void agregar (Forma forma)
    {
        _figuras.add (forma);
    }
    
    /**
     *Metodo que permite Escalar, es decir, cambia el tamano de las formas de la figura
     *@param centro Centro relativo del Escalamiento.
     *@param factor Factor de Escalamiento
     */
    public void escalar (Point centro, double factor)
    {
        for(int i=0; i < _figuras.size(); i++)
        {
            ((Forma)_figuras.get(i)).escalar (centro, factor);
        }
    }
    
    /**
     *Metodo que permite Rotar, es decir, gira las formas en el angulo dado respecto al centro de rotacion dado
     *@param centro Centro de Rotacion
     *@param deltaAngulo Angulo de Rotacion
     */
    public void rotar (Point centro, double deltaAngulo)
    {
        for(int i=0; i < _figuras.size(); i++)
        {
            ((Forma)_figuras.get(i)).rotar (centro, deltaAngulo);
        }
    }
    
    /**
     *Metodo que permite Trasladar, es decir, cambia la posicion de las formas
     *@param deltaX Desplazamiento horizontal
     *@param deltaY Desplazamiento vertical
     */
    public void trasladar (double deltaX, double deltaY)
    {
        for(int i=0; i < _figuras.size(); i++)
        {
            ((Forma)_figuras.get(i)).trasladar (deltaX, deltaY);
        }
    }
    
    /**
     *Metodo que permite mostrar en consola las Formas que componen la Figura
     *@return Arreglo de Formas de la Figura
     */
    public String toString ()
    {
        String salida = "Figura compuesta de " + _figuras.size() + " formas:";
        for(int i=0; i < _figuras.size(); i++)
        {
            salida+="\n    Forma " + (i+1) + ": " + ((Forma)_figuras.get(i)).toString();
        }
        return salida;
    }
}
/**Fin subclase Figura
*Principal dificultad: Definir el arreglo que permite agrupar las figuras
*Solucion: Documentarse en el uso de AarrayList y usar un ciclo
 */