import java.awt.*;
import java.lang.Math.*;
import java.lang.Character.*;
import java.util.*;
import java.io.*;

/**
 *Clase que permite comprobar el correcto funcionamiento del proyecto
 *@author Patricio A. Castillo Pizarro - Eric C. Maldonado Olguin
 *@version 0.3 - April 12th, 2007
 */
public class TestFigura
{
    /**
     *Es el constructor. Inicializa una nueva figura vacia.
     */
    public TestFigura ()
    {
        ;
    }
    
    /**
     *Metodo que permite crear formas y agregarlas a una figura
     *@return La figura con las formas creadas
     */
    public Figura figuraFactory () throws IOException 
    {
        String opcion = "NADA";
        String texto = "NADA";
        Figura figura1 = new Figura ();
        
        /**Stream y Buffer de lectura para recibir la entrada por consola*/
        InputStreamReader input = new InputStreamReader(System.in);
        BufferedReader buffer = new BufferedReader(input);
        
        System.out.println (">>>Fabrica de Figuras:");
        while ((opcion.compareTo ("3")) != 0)
        {
            /**Menus de texto. Mientras no se escoja la opcion 3 permanece activo en el metodo actual*/
            System.out.println ("\nEscoja su opcion:\n    1 : Crear Rectangulo\n    2 : Crear Circulo\n    3 : Salir");
            opcion = buffer.readLine ();
            if ((opcion.compareTo ("1")) == 0)
            { 
                double aX = 0;
                double aY = 0;
                double bX = 0;
                double bY = 0;
                System.out.println ("...Creando Rectangulo:\n    Ingrese valor X del primer punto:");
                texto = buffer.readLine ();
                aX = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor Y del primer punto:");
                texto = buffer.readLine ();
                aY = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor X del segundo punto:");
                texto = buffer.readLine ();
                bX = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor Y del segundo punto:");
                texto = buffer.readLine ();
                bY = Double.parseDouble (texto);
                Point a = new Point ();
                a.setLocation (aX, aY);
                Point b = new Point ();
                b.setLocation (bX, bY);
                Rectangulo rectangulo1 = new Rectangulo (a,b);
                System.out.println ("...Creado:" + rectangulo1.toString());
                figura1.agregar (rectangulo1);
                System.out.println (figura1.toString());
            }
            if ((opcion.compareTo ("2")) == 0)
            {
                double cX = 0;
                double cY = 0;
                double r = 0;
                System.out.println ("...Creando Circulo:\n    Ingrese valor X del centro:");
                texto = buffer.readLine ();
                cX = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor Y del centro:");
                texto = buffer.readLine ();
                cY = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor del radio:");
                texto = buffer.readLine ();
                r = Double.parseDouble (texto);
                Point c = new Point ();
                c.setLocation (cX, cY);
                Circulo circulo1 = new Circulo (c,r);
                System.out.println ("...Creado:" + circulo1.toString());
                figura1.agregar (circulo1);
                System.out.println ("\n" + figura1.toString());
            }
        }
        System.out.println ("\nHa salido de la Fabrica de Figuras");
        return figura1;
    }
    
    /**
     *Metodo que permite manipular formas
     *@param f La forma que se desea manipular
     */
    public void manipularForma (Forma f) throws IOException
    {
        String opcion = "NADA";
        String texto = "NADA";
        
        /**Stream y Buffer de lectura para recibir la entrada por consola*/
        InputStreamReader input = new InputStreamReader(System.in);
        BufferedReader buffer = new BufferedReader(input);
        
        System.out.println ("\n>>>Manipular Forma:\n" + f.toString());
        while ((opcion.compareTo ("4")) != 0)
        {
            /**Menus de texto. Mientras no se escoja la opcion 4 permanece activo en el metodo actual*/
            System.out.println ("\nEscoja su opcion:\n    1 : Rotar\n    2 : Trasladar\n    3 : Escalar\n    4 : Salir");
            opcion = buffer.readLine ();
            if ((opcion.compareTo ("1")) == 0)
            {
                double cX = 0;
                double cY = 0;
                double angulo = 0;
                System.out.println ("...Rotando Forma:\n    Ingrese valor X del centro de rotacion:");
                texto = buffer.readLine ();
                cX = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor Y del centro de rotacion:");
                texto = buffer.readLine ();
                cY = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor del angulo de rotacion:");
                texto = buffer.readLine ();
                angulo = Double.parseDouble (texto);
                Point centro = new Point ();
                centro.setLocation (cX, cY);
                f.rotar (centro, angulo);
                System.out.println ("\nSobre la forma se realizo una Rotacion:\n" + f.toString());
            }
            if ((opcion.compareTo ("2")) == 0)
            {
                double dX = 0;
                double dY = 0;
                System.out.println ("...Trasladando Forma:\n    Ingrese valor de traslacion horizontal:");
                texto = buffer.readLine ();
                dX = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor de traslacion vertical:");
                texto = buffer.readLine ();
                dY = Double.parseDouble (texto);
                f.trasladar (dX, dY);
                System.out.println ("\nSobre la forma se realizo una Traslacion:\n" + f.toString());
            }
            if ((opcion.compareTo ("3")) == 0)
            {
                double cX = 0;
                double cY = 0;
                double factor = 0;
                System.out.println ("...Escalando Forma:\n    Ingrese valor X del centro de escalamiento:");
                texto = buffer.readLine ();
                cX = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor Y del centro de escalamiento:");
                texto = buffer.readLine ();
                cY = Double.parseDouble (texto);
                System.out.println ("    Ingrese valor del factor de escalamiento:");
                texto = buffer.readLine ();
                factor = Double.parseDouble (texto);
                Point centro = new Point ();
                centro.setLocation (cX, cY);
                f.escalar (centro, factor);
                System.out.println ("\nSobre la forma se realizo un Escalamiento:\n" + f.toString());
            }
        }
        System.out.println ("\nHa salido del Manipulador de Formas");
    }
    
    /**
     *Metodo Principal que ejecuta el programa de prueba
     */
    public static void main (String[] args) throws IOException
    {
        TestFigura test = new TestFigura ();
        Figura figura1 = new Figura ();
        System.out.println ("\nComprobando el funcionamiento de los metodos del proyecto...\n");
        figura1 = test.figuraFactory ();
        test.manipularForma (figura1);
    }
}
/**Fin clase TestForma
*Principal Dificultad: Definir el Stream y Buffer de que permiten recibir los datos por consola
*Solucion: Documentarse en los metodos de recibir entradas por consola
 */